<?php

namespace Teknisa\MAN\Controllers;

use Zeedhi\Framework\Controller\CrudWithParameterBag;
use Zeedhi\Framework\DataSource\ParameterBag;
use Zeedhi\Framework\DTO;
use Zeedhi\Framework\DataSource\DataSet;
use Zeedhi\Framework\DTO\Response\Notification;
use Zeedhi\Framework\DataSource\Manager;
use Teknisa\MAN\Services;
use Teknisa\MAN\Utilities;
use \Exception as Exception;

class Catraca extends CrudWithParameterBag {
    const dataSourceCatraca = 'catraca';
    protected $parameterBagColumns = ['NRORG', 'CDFILIAL', 'CDCAIXA', 'IDMODCATRACA'];

    public function __construct(ParameterBag $parameterBag, Manager $dataSourceManager, Utilities\Util $util, $environment, Services\CatracaService $catracaService) {
        $this->parameterBag = $parameterBag;
        $this->dataSourceManager = $dataSourceManager;
        $this->util = $util;
        $this->environment = $environment;
        $this->CatracaService = $catracaService;
    }



    public function find(DTO\Request\Filter $request, DTO\Response $response) {
        $this->dataSourceName = self::dataSourceCatraca;
        parent::find($request, $response);
    }
    
    public function save(DTO\Request\DataSet $request, DTO\Response $response) {
        $this->dataSourceName = self::dataSourceCatraca;
        $this->environment->getNrOrgTrab();
        $dataSet = $request->getDataSet();
        $rows = $dataSet->getRows();
        unset($rows[0]['NMFILIAL']);
        unset($rows[0]['NMCAIXA']);
         try {
    	    if($rows[0]['__is_new']) {
                $this->CatracaService->save($rows);
    	    } else {
    	        $this->CatracaService->update($rows);
    	    }
        } catch (Exception $e) {
            $response->setError(new DTO\Response\Error($e->getMessage(), $e->getCode()));
        }
    }
    
    public function delete(DTO\Request\DataSet $request, DTO\Response $response) {
        try {
            $params = $this->util->getParamsAsArray($request);
            unset($params[0]['NMFILIAL']);
            unset($params[0]['NMCAIXA']);
            $this->CatracaService->delete($params);
        } catch (\Exception $e) {
            $response->setError(new DTO\Response\Error($e->getMessage(), $e->getCode(), $e->getTraceAsString()));
        }
    }
    
    
}