<?php
namespace Teknisa\MAN\Controllers;

use Zeedhi\Framework\Controller\CrudWithParameterBag;
use Zeedhi\Framework\DataSource\DataSet;
use Zeedhi\Framework\DataSource\Manager;
use Zeedhi\Framework\DataSource\ParameterBag;
use Zeedhi\Framework\DTO;
use Zeedhi\Framework\DTO\Response\Notification;
use Zeedhi\Framework\DTO\Response\Message;
use Teknisa\MAN\Utilities;
use Zeedhi\Framework\DataSource\FilterCriteria;
use \Datetime;

class RelTransfMovimentacao extends CrudWithParameterBag {
    protected $parameterBag;
    protected $novoCodigo; 
    
    public function __construct (Manager $dataSourceManager, ParameterBag $parameterBag, $crudService, Utilities\Util $util){
        $this->crudService = $crudService;
        $this->util = $util;
        parent::__construct($dataSourceManager, $parameterBag);
    }
    
    protected $dataSourceNameArray = array (
        'log' => 'vnd02901_reltranfmovimentacao'
    );
    protected $parameterBagColumnsArray = array (
        'log' => array('NRORG', 'CDFILIAL', 'CDOPERADOR', 'TCDOPERADOR', 'DTINIC', 'DTFINAL')
    );
    
    public function find(DTO\Request\Filter $request, DTO\Response $response) {
        $conditions = $request->getFilterCriteria()->getConditions();
        $filters = $this->util->getParamsAsArray($request);
        unset($filters['NMFILIAL']);
        unset($filters['TIPO']);
        
        if(isset($filters['PERIODO'])) {
            //manipula array NMOPERADOR_V para string CDOPERADOR
            $filters = $this->util->buildParams('CDOPERADOR', $filters);
            $filters['DTINIC'] = $filters['PERIODO'][0];
            $filters['DTFINAL'] = $filters['PERIODO'][1];
            unset($filters['PERIODO']);
            
            $this->dataSourceName = $this->dataSourceNameArray['log'];
            $this->parameterBagColumns = $this->parameterBagColumnsArray['log'];
            
            $newRequest = $this->util->createNewZeedhiFilterRequestObject($request, $this->dataSourceName, $filters);
            
            foreach($this->parameterBagColumns as $field => $value){
                $newRequest->getFilterCriteria()->addCondition($value, '=', $filters[$value]);
            }
            parent::find($newRequest, $response);
        } else {
            return null;
        }
    }
    
    
}